# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- test
- deploy

sast:
  stage: test
include:
- template: Security/SAST.gitlab-ci.yml

unit:
  variables:
    DOMAIN_CERTIFICATE_FILE: 'domain.pem'
    DOMAIN_CERTIFICATE_KEY_FILE: 'domain.key'
    VC_PRIVKEY: 'vc-ed25519-priv.pem'
  stage: test
  image: node:16-bullseye
  before_script:
    # - curl https://sh.rustup.rs --output install_rust.sh # install Rust for Didkit
    # - sh ./install_rust.sh -y
    # - source $HOME/.cargo/env
    - npm install --include=dev
  script:
    - openssl genpkey -algorithm ed25519 -outform PEM -out $VC_PRIVKEY
    - openssl req -nodes -x509 -newkey rsa:2048 -subj "/C=FR/ST=Nord/L=Lille/O=CI-test/OU=Org/CN=www.example.com" -keyout $DOMAIN_CERTIFICATE_KEY_FILE -out $DOMAIN_CERTIFICATE_FILE -sha256 -days 365 2>/dev/null
    - npm test

deploy:
  variables:
    GIT_SSH_COMMAND: ssh -o UserKnownHostsFile=/dev/null -o StrictHostKeyChecking=no
  stage: deploy
  image:
    name: bitnami/git
  before_script:
    - eval $(ssh-agent -s)
    - echo "$CC_GIT_PRIVATE_KEY" | tr -d '\r' | ssh-add -
  script:
    - git remote add clever git+ssh://git@push-n2-par-clevercloud-customers.services.clever-cloud.com/app_52cf9b76-83a2-40ef-84ad-b0bf5bed85cf.git || true
    - git push clever HEAD:master
  only:
    - main
